/*
** Splint - annotation-assisted static program checker
** Copyright (C) 1994-2003 University of Virginia,
**         Massachusetts Institute of Technology
**
** This program is free software; you can redistribute it and/or modify it
** under the terms of the GNU General Public License as published by the
** Free Software Foundation; either version 2 of the License, or (at your
** option) any later version.
** 
** This program is distributed in the hope that it will be useful, but
** WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
** General Public License for more details.
** 
** The GNU General Public License is available from http://www.gnu.org/ or
** the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
** MA 02111-1307, USA.
**
** For information on splint: info@splint.org
** To report a bug: splint-bug@splint.org
** For more information: http://www.splint.org
*/
/*
** cstringHash.c
*/

# include "splintMacros.nf"
# include "basic.h"
# include "cstringHash.h"

/*@constant int NUM_RANDOM=256@*/
# define NUM_RANDOM 256

/*@+ignoresigns@*/
static const unsigned int
g_randomNumbers[NUM_RANDOM] = {
  0x7be9c1bd,
  0x088aa102,
  0x3d38509b,
  0x746b9fbe,
  0x2d04417f,
  0x775d4351,
  0x53c48d96,
  0x02b26e0b,
  0x418fedcf,
  0x19dbc19e,
  0x78512adb,
  0x1a1f5e2b,
  0x307d7761,
  0x6584c1f0,
  0x24e3c36f,
  0x2232310f,
  0x2dac5ceb,
  0x106e8b5a,
  0x5a05a938,
  0x5e6392b6,
  0x66b90348,
  0x75264901,
  0x4174f402,
  0x618b18a4,
  0x3a6ab4bf,
  0x3c4bc289,
  0x2657a9a9,
  0x4e68589b,
  0x09648aa6,
  0x3fc489bb,
  0x1c1b715c,
  0x054e4c63,
  0x484f2abd,
  0x5953c1f8,
  0x79b9ec22,
  0x75536c3d,
  0x50b10549,
  0x4d7e79b8,
  0x7805da48,
  0x1240f318,
  0x675a3b56,
  0x70570523,
  0x2c605143,
  0x17d7b2b7,
  0x55dbc713,
  0x514414b2,
  0x3a09e3c7,
  0x038823ff,
  0x61b2a00c,
  0x140f8cff,
  0x61ebb6b5,
  0x486ba354,
  0x0935d600,
  0x2360aab8,
  0x29f6bbf8,
  0x43a08abf,
  0x5fac6d41,
  0x504e65a2,
  0x1208e35b,
  0x6910f7e7,
  0x1012ef5d,
  0x2e2454b7,
  0x6e5f444b,
  0x58621a1b,
  0x077816af,
  0x6819306d,
  0x4db58658,
  0x58291bf8,
  0x3597aa25,
  0x45bb60a0,
  0x6a6a0f11,
  0x1cf1e57c,
  0x361265c4,
  0x16ca6054,
  0x34c99833,
  0x0bee2cd7,
  0x680e7507,
  0x6ed37bfa,
  0x0f7650d6,
  0x49c11513,
  0x02e308f9,
  0x7162078c,
  0x122cb868,
  0x0c18defa,
  0x14c2b244,
  0x3c237460,
  0x4fb969b9,
  0x746f1f85,
  0x0c71da02,
  0x61c24d14,
  0x5d80176d,
  0x1c84c960,
  0x0fe6a1cc,
  0x4bdf5bb8,
  0x74e6e37b,
  0x175eb87b,
  0x33f88c25,
  0x429c69d3,
  0x6f87d474,
  0x6990364a,
  0x0857ca73,
  0x59f1e385,
  0x06821bc6,
  0x3e6a3037,
  0x70bc43d9,
  0x3b4bb3fa,
  0x4a585d0f,
  0x58cab8e0,
  0x2a1f2ff4,
  0x59ceade5,
  0x228bcdf4,
  0x2d0238ee,
  0x4b30b571,
  0x34b8865c,
  0x391b17e8,
  0x5ff367b5,
  0x70dbfabc,
  0x08d481a1,
  0x5462873b,
  0x7d4dd4bf,
  0x6a96ceb6,
  0x31e29ea8,
  0x19d29e1f,
  0x7a7d7082,
  0x7dc1fa60,
  0x0eb9819a,
  0x11dc28fd,
  0x31ba8685,
  0x5155eb6d,
  0x0163fd71,
  0x1b4abccf,
  0x59adb5e0,
  0x5b55e0f6,
  0x21ccd896,
  0x1817e618,
  0x4c1224d0,
  0x5d188c90,
  0x62704327,
  0x24dcddb0,
  0x0737bc84,
  0x3c3ef10c,
  0x4768aba4,
  0x3439f572,
  0x076fa67e,
  0x7c213200,
  0x6d550d5a,
  0x67630e33,
  0x6cfd2cbd,
  0x76298efc,
  0x3bc5956e,
  0x6a4b017c,
  0x60c05db2,
  0x6da83416,
  0x041d9f9b,
  0x5b3dce34,
  0x6b6a2e76,
  0x12d72135,
  0x6d19f731,
  0x1d24b4fb,
  0x642d0ca2,
  0x6e7df4a3,
  0x386f71cb,
  0x3ddac282,
  0x49d3d599,
  0x5a3c4a61,
  0x55f2a89a,
  0x15e5fa69,
  0x3754d6f1,
  0x3862ebc1,
  0x3ac2d81a,
  0x3e8c9375,
  0x74a1dcce,
  0x022b83be,
  0x72c688e8,
  0x7c11834c,
  0x7e4cb5bf,
  0x601b9642,
  0x6374917f,
  0x6b49e27c,
  0x5645253e,
  0x1f3a26ee,
  0x5594e3f8,
  0x370582f0,
  0x0ce25b04,
  0x59b28393,
  0x12435124,
  0x784c897b,
  0x6c89a4c8,
  0x7f5d4856,
  0x15713e76,
  0x50b6b16a,
  0x6ddb3cf9,
  0x4de0b041,
  0x0e9173ec,
  0x37af1292,
  0x281cfaa2,
  0x64841c87,
  0x4d950cfc,
  0x5f71d193,
  0x1ce70848,
  0x0857e516,
  0x1dfe6509,
  0x1188e516,
  0x0a8368d4,
  0x10c4edf1,
  0x0d9a6862,
  0x08d01e93,
  0x70e08433,
  0x710ef9e2,
  0x741a010f,
  0x4725a972,
  0x104920d0,
  0x49aee507,
  0x7e2b2c62,
  0x1d2b7bd4,
  0x2361689a,
  0x106e7d87,
  0x1578054f,
  0x0feb0d62,
  0x0fcbc5dd,
  0x2ae943c6,
  0x60a1becc,
  0x7da702d6,
  0x78c9f407,
  0x6f3332b9,
  0x35561568,
  0x20e6eeaa,
  0x53b74f40,
  0x02eb2264,
  0x0058c03d,
  0x709e5788,
  0x0b43077a,
  0x1e572546,
  0x02273c9f,
  0x15c6704f,
  0x2f1c1337,
  0x0fc1a501,
  0x1e968ee2,
  0x1ffc976b,
  0x00d09ee3,
  0x12b08ff2,
  0x672240dd,
  0x1119bfb3,
  0x5c5f74f9,
  0x654d6d3f,
  0x2e453b88,
  0x7fc0dd94,
  0x75bbeac6,
  0x43bd40d7,
  0x0fabeaf6,
  0x0587b0a3,
  0x6ea6849d,
  0x704da9c3,
  0x032eb379,
  0x677078a5,
  0x5f80dc7c
} ;
/*@=ignoresigns@*/

/*
** hash function snarfed from quake/hash.c Hash_String
** by Stephen Harrison
*/

unsigned int 
cstring_hashValue (cstring key)
{
  char *p;
  unsigned int hash_value = 0;

  for (p = cstring_toCharsSafe (key); *p != '\0'; p++)
    {
      hash_value = (hash_value << 1) ^ g_randomNumbers[*p % NUM_RANDOM];
    }

  return hash_value;
}

